import java.util.*;

/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung.
*/
public class Aufgabe1 {

    /*
    Aufgabe: Umgang mit Klassen und Objekten, sowie vorgefertigten Datenstrukturen.

        Ergänzen Sie fehlende Teile der untenstehenden Klassen entsprechend den Kommentaren
        nur an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 40):

        32 Punkte in Summe für Klasse 'Potion':
            6 Punkte für Konstruktoren und Variable
            5 Punkte für 'add',
            6 Punkte für 'stir' und 'ready',
            6 Punkte für 'power',
            9 Punkte für 'mixWith',
        8 Punkte für Klasse 'Cabinet':
            8 Punkte für 'put'

    */

    // Diese Methode können Sie zum Testen der Klassen 'Potion' und 'Cabinet'
    // verwenden. Diese Methode wird nicht bewertet.
    public static void main(String[] args) {

        // Überprüft die korrekte Basisimplementierung der Klasse 'Potion':
        // Konstruktoren und 'toString'
        // Erwarteter Output:
        // [Bergblume, Säbelzahntigerauge]:27
        // [Bergblume, Weizen]:15
        // [Mondfalterflügel, Vampirstaub]:27
        Potion healing1 = new Potion(new String[]{"Bergblume","Säbelzahntigerauge"});
        Queue<Ingredient> ingr = new LinkedList<Ingredient>();
        ingr.offer(new Ingredient("Bergblume"));
        ingr.offer(new Ingredient("Weizen"));
        Potion healing2 = new Potion(ingr);
        Potion invisibility = new Potion(new String[]{"Mondfalterflügel","Vampirstaub"});
        System.out.println(healing1);
        System.out.println(healing2);
        System.out.println(invisibility);

        // Überprüft die korrekte Implementierung der von 'stir':
        // Erwarteter Output:
        // [Bergblume, Säbelzahntigerauge]:54
        healing1.stir();
        healing1.stir();
        System.out.println(healing1);

        // Überprüft die korrekte Basisimplementierung der Klasse 'Cabinet':
        // Konstruktoren und 'toString'
        // Erwarteter Output (Reihenfolge kann abweichen):
        // {Heilung=[Bergblume, Säbelzahntigerauge, Weizen]:66, Unsichtbarkeit=[Mondfalterflügel, Vampirstaub]:54}
        Cabinet potionArchive = new Cabinet();
        potionArchive.put("Heilung", healing1);
        potionArchive.put("Heilung", healing2);
        potionArchive.put("Unsichtbarkeit", invisibility);
        System.out.println(potionArchive);

    }

}

// 'Ingredient' repräsentiert eine Zutat mit einem Namen. Die Stärke der Zutat entspricht der
// Länge des Namens.
class Ingredient {

    private String name;

    // Konstruktor
    public Ingredient(String name) {
        this.name = name;
    }

    // liefert die Stärke dieser Zutat.
    public int strength() {
        return name.length();
    }

    // liefert eine lesbare Reäräsentation der Zutat.
    public String toString() {
        return name;
    }

    // liefert 'true' wenn diese Zutat dem angegebenen Objekt gleicht, sonst false.
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if (o.getClass() != Ingredient.class) {
            return false;
        }
        Ingredient i = (Ingredient) o;

        return i.name.equals(this.name);
    }

    // liefert einen Hashcode dieser Zutat.
    public int hashCode() {
        return name.hashCode();
    }
}

// Potion ist ein Zaubertrank mit einer beliebigen Anzahl an Zutaten. Er hat eine beliebige Anzahl an
// Zutaten und eine bestimmte Stärke, die sich aus der Summe der Stärken der Zutaten ergibt.
// Wird er ausreichend oft umgerührt, ist er fertig und wirkt doppelt so stark.
class Potion {

    // Objektvariable zum Speichern der Zutaten.
    private Queue<Ingredient> ingredients;
    private int toBeStired = 0;

    //TODO: deklarieren Sie hier weitere benötigte Variable(n).

    // Fügt diesem Zaubertrank eine einzelne Zutat hinzu, aber nur dann wenn dieser
    // Zaubertrank noch keine gleiche Zutat enthält, sonst macht 'add' nichts.
    public void add(Ingredient ingredient) {
        //TODO: implementieren Sie den Konstruktor.
        //ingredients = new LinkedList<>();

        for(Ingredient s : ingredients) {
            if(s.hashCode() == ingredient.hashCode()){
                return;
            } else {
                ingredients.add(ingredient);
            }
        }

    }

    // Konstruktor: initialisiert diesen Zaubertrank mit angegebenen Zutaten (ingredients),
    // die durch deren Namen angegeben werden.
    // Ist eine gleiche Zutaten mehrmals in ingredients enthalten, wird Sie nur einmal
    // hinzugefügt.
    public Potion(String[] ingredients) {

        this.ingredients = new LinkedList<>();
        //TODO: implementieren Sie den Konstruktor.
        for(int i = 0; i < ingredients.length; i++){
            this.ingredients.offer(new Ingredient(ingredients[i]));
        }


    }

    // Ein weiterer Konstruktor: verhält sich wie obiger Konstruktor, nur werden die
    // Zutaten mittels Paremeter vom Typ 'Queue<Ingredient>' angegeben.
    public Potion(Queue<Ingredient> ingredients) {

        this.ingredients = new LinkedList<>();
        for(Ingredient s : ingredients){
            this.ingredients.offer(s);
        }
        //TODO: implementieren Sie den Konstruktor.

    }

    // Rührt den Zaubertrank einmal um.
    public void stir() {
        this.toBeStired++;
        //TODO: implementieren Sie diese Methode.

    }

    // Gibt an, ob der Zaubertrank fertig ist, d.h. ausreichend oft umgerührt wurde.
    // Ein Zaubertrank muss, damit er fertig ist, mindestens so oft umgerührt werden,
    // wie die Anzahl der enthaltenen Zutaten ist.
    public boolean ready() {
        int count = 0;



        if(this.toBeStired == this.ingredients.size()){
            return true;
        } else {
            //TODO: implementieren Sie diese Methode.
            return false;
        }//TODO: diese Zeile entfernenimplementieren.

    }

    // Liefert die Stärke des Zaubertranks (int). Die Stärke ist die Summe
    // der Stärken aller Zutaten, solange der Zaubertrank
    // nicht fertig ist. Ist er fertig, wirkt er doppelt so stark.
    public int power() {
        int count = 0;
        for(Ingredient s : this.ingredients){
            count += s.strength();
        }
        if(this.ready()){
            return 2*count;
        } else {
            return count;
        }
        //TODO: implementieren Sie diese Methode.
         //TODO: diese Zeile entfernen.

    }



    // Liefert eine fertig umgerührte Mischung, die alle Zutaten aus diesem Zaubertrank
    // und 'potionToMix' enthält. Dieser Zaubertrank und 'potionToMix' bleiben dabei
    // unverändert.
    public Potion mixWith(Potion potionToMix) {
        ;

        String[] ingr = new String[this.ingredients.size() + potionToMix.ingredients.size()];
        int i = 0;
        for(Ingredient s : this.ingredients){
                ingr[i] = s.hashCode() + "";
                i++;
        }
        int k = this.ingredients.size()-1;
        for(Ingredient s : potionToMix.ingredients){
            ingr[k] = s.hashCode() + "";
            k++;
        }

        Potion temp = new Potion(ingr);
        //TODO: implementieren Sie diese Methode.
        return temp; //TODO: diese Zeile entfernen.

    }

    // Liefert einen String mit einer Liste der Zutaten in eckigen Klammern
    // gefolgt von einem ':' und der Stärke des Zaubertranks, also z.B.:
    // [Bergblume, Säbelzahntigerauge]:27
    public String toString() {
        return ingredients + ":" + power();

    }

}

// Repäsentiert einen Schrank mit Zaubertränken. Es können beliebig viele Tränke in den Schrank gestellt werden.
// Jeder Trank im Schrank bekommt eine Beschreibung seines Effektes.
class Cabinet {

    private Map<String, Potion> potions;

    // Erzeugt einen leeren Schrank.
    public Cabinet() {
        potions = new TreeMap<>();

    }

    // Stellt einen Zaubertrank in den Schrank. Dabei wird die Beschreibung 'effect'
    // als Schlüssel verwendet. Gibt es im Schrank bereits einen Zaubertrank mit der
    // angegebenen Beschreibung, wird 'potionToPut' dem bereits vorhandenen Zaubertrank
    // gemischt und die Mischung mit dieser Beschreibung gespeichert.
    // In jedem Fall sorgt 'put' dafür, dass jeder Zaubertrank, der in den Schrank
    // gestellt wird, fertig ist (siehe Klasse 'Potion'),
    // d.h. er wird ggfs. vorher ausreichend oft umgerührt.
    public void put(String effect, Potion potionToPut) {

        for(String s : potions.keySet()){
            if(s.equals(effect)){
                potions.put(effect, potionToPut.mixWith(potions.get(s)));
            } else{
                potions.put(effect, potionToPut);
            }
        }
        potions.put(effect, potionToPut);

        //TODO: implementieren Sie diese Methode.

    }

    // Liefert eine lesbare Repräsentation (String) des Schranks in
    // folgendem Format:
    // {effect=Zaubertrank, effect=Zaubertrank, ... }
    // also z.B.
    // {Heilung=[Bergblume, Säbelzahntigerauge, Bergblume, Weizen]:66, Unsichtbarkeit=[Mondfalterflügel, Vampirstaub]:54}
    public String toString() {

        return potions.toString();

    }

}

