/*
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
Verwenden Sie die gegebenen Testklassen zum Überprüfen Ihrer Lösung. Die Korrektheit dieser Testfälle
ist notwendig, aber nicht hinreichend für eine korrekte Lösung.
*/
public class Aufgabe2 {

    /*
    Aufgabe:
        Objekte der Klasse Tree stellen binäre Suchbäume über ganzen Zahlen mit Knoten vom Typ Node dar.
        Ergänzen Sie fehlende Teile der Klasse entsprechend den Kommentaren nur
        an den mit TODO gekennzeichneten Stellen.

    Punkte (maximal 20):
        10 Punkte für copyTree,
        10 Punkte für toString.
        Auch für teilweise korrekte Lösungen werden Punkte vergeben.
    */

    // Nur zum Testen (geht nicht in die Beurteilung ein).
    public static void main(String[] args) {

        Tree tree = new Tree();
        tree.add(5);
        tree.add(2);
        tree.add(7);
        tree.add(6);
        tree.add(8);
        tree.add(1);
        tree.add(1);
        tree.add(3);

        System.out.println(tree); // (#8#7#6#5#3#2#1#1#)
        System.out.println();

        Tree myTree = new Tree();
        System.out.println(myTree); // ()
        System.out.println();

        myTree = tree.copyTree();

        System.out.println(myTree); // (#8#7#6#5#3#2#1#1#)
        System.out.println();
        System.out.println(tree); // (#8#7#6#5#3#2#1#1#)
        System.out.println();

        myTree.add(4);

        System.out.println(myTree); // (#8#7#6#5#4#3#2#1#1#)
        System.out.println();
        System.out.println(tree); // (#8#7#6#5#3#2#1#1#)
        System.out.println();

    }
}

class Node {

    // Keine zusätzlichen Varibalen definieren.
    int elem;
    Node left;
    Node right;

    // Den Konstruktor nicht verändern.
    Node(int elem) {
        this.elem = elem;
        this.left = null;
        this.right = null;
    }

    // Rekursive Hilfsmethode für 'add' von 'Tree'.
    void add(int elem) {
        if (elem < this.elem) {
            if (this.left == null) {
                this.left = new Node(elem);
            } else {
                this.left.add(elem);
            }
        } else {
            if (this.right == null) {
                this.right = new Node(elem);
            } else {
                this.right.add(elem);
            }
        }
    }

    // Rekursive Hilfsmethode für 'copyTree' von 'Tree'.
    Node copyTree() {
        // TODO: Implementieren Sie die Methode
        Node copy = new Node(this.elem);

        if(this.left != null){
            copy.left = this.left.copyTree();
        }

        if(this.right != null){
            copy.right = this.right.copyTree();
        }

        return copy; //TODO: Diese Zeile löschen.
    }

    @Override
    // Rekursive Hilfsmethode für 'toString' von 'Tree'.
    public String toString() {
        String s = "#" + Integer.toString(this.elem);

        if(right != null){
            s = this.right.toString() /*+ "#" */+ s;
        }

        if(left != null){
            s += /*"#" +*/ this.left.toString();
        }

        // TODO: Implementieren Sie die Methode
            return s; //TODO: Diese Zeile löschen.
    }
}


class Tree {

    // Der Wurzelknoten des Baumes. Bitte nicht verändern, oder zusätzliche
    // Variablen hinzufügen.
    private Node root;

    public boolean empty() {
        return this.root == null;
    }

    // Fügt neue Elemente in den Baum ein.
    // z.B. Die Aufrufe add(5),add(2),add(7),add(6),add(8),add(1),add(1),add(3)
    // ergeben folgenden Baum:
    //              5
    //           /    \
    //         2        7
    //       /   \     /  \
    //      1     3   6    8
    //       \
    //        1
    public void add(int elem) {
        if (empty()) {
            this.root = new Node(elem);
        } else {
            this.root.add(elem);
        }
    }

    // Diese Methode kopiert den vorhandenen Baum und erstellt eine exakte tiefe
    // Kopie. Dafür sollen keine zusätzlichen Datenstrukturen verwendet werden.
    public Tree copyTree() {
        if(empty()){
            return null;
        } else{
            Tree copy = new Tree();
            copy.root = root.copyTree();
            return copy;
        }
        // TODO: Implementieren Sie die Methode
         //TODO: Diese Zeile löschen.

    }

    // Retourniert alle Elemente des Baumes in absteigender Reihenfolge als
    // String.
    // z.B. der Baum enthält 1, 2, 3 and 4, dann ist das Ergebnis:
    // "(#4#3#2#1#)"
    // Für einen leeren Baum wird "()" zurückgegeben.
    @Override
    public String toString() {
        if(root == null){
            return "()";
        } else{
            return "(" + root.toString() + "#" + ")";
        }
        // TODO: Implementieren Sie die Methode
         //TODO: Diese Zeile löschen.
    }


}


