import org.junit.Assert;
import org.junit.Test;

import static org.hamcrest.CoreMatchers.is;

public class Aufgabe2Test {

    @Test
    public void testCopyTree() throws Exception {

        Tree t1 = new Tree();
        t1.add(5);
        t1.add(2);
        t1.add(7);
        t1.add(6);
        t1.add(8);
        t1.add(1);
        t1.add(1);
        t1.add(3);

        Tree t2;
        t2 = t1.copyTree();
        Assert.assertThat(t2.toString().replaceAll("\\s", "").replaceAll("\\.",
                ""), is("(#8#7#6#5#3#2#1#1#)"));
    }

    @Test
    public void testCopyTreeChange() throws Exception {

        Tree t1 = new Tree();
        t1.add(5);
        t1.add(2);
        t1.add(7);
        t1.add(6);
        t1.add(8);
        t1.add(1);
        t1.add(1);
        t1.add(3);

        Tree t2 = t1.copyTree();
        t2.add(4);
        Assert.assertThat(t2.toString().replaceAll("\\s", "").replaceAll("\\.",
                ""), is("(#8#7#6#5#4#3#2#1#1#)"));
        Assert.assertThat(t1.toString().replaceAll("\\s", "").replaceAll("\\.",
                ""), is("(#8#7#6#5#3#2#1#1#)"));
    }

    @Test
    public void testCopyTreeRoot() throws Exception {

        Tree t1 = new Tree();
        t1.add(5);

        Tree t2 = t1.copyTree();
        Assert.assertThat(t2.toString().replaceAll("\\s", "").replaceAll("\\.",
                ""), is("(#5#)"));
    }

    @Test
    public void testCopyTreeEmpty() throws Exception {

        Tree t1 = new Tree();

        Tree t2 = t1.copyTree();
        Assert.assertThat(t2.toString().replaceAll("\\s", "").replaceAll("\\.",
                ""), is("()"));
    }

    @Test
    public void testToString() throws Exception {

        Tree t1 = new Tree();
        t1.add(5);
        t1.add(2);
        t1.add(7);
        t1.add(6);
        t1.add(8);
        t1.add(1);
        t1.add(1);
        t1.add(3);

        Assert.assertThat(t1.toString().replaceAll("\\s", "").replaceAll("\\.", ""),
                is("(#8#7#6#5#3#2#1#1#)"));
    }

    @Test
    public void testToStringEmpty() throws Exception {

        Tree t1 = new Tree();
        Assert.assertThat(t1.toString().replaceAll("\\s", "").replaceAll("\\.", ""),
                is("()"));
    }
}